﻿'' Read or Make STEP-NC Process using VB anf Forms
'' ========================================
''
'' This sample VB code calls the STEP-NC API using the .NET interface.
'' Two functions below show how to create new data or read and
'' traverse existing data sets.
''
'' You can find more examples and other programming documentation at:
''
''      http://www.steptools.com/support/
''

Imports STEPNCLib

Public Class Form1

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        '' ReadSTEPNC() to read existing data
        '' MakeSTEPNC() to create new data

        Close()
    End Sub

    Sub ReadSTEPNC()
        Dim finder As finder = New finder
        Dim ctl As Adaptive = New Adaptive

        '' Read a STEP-NC file
        finder.Open238("C:/Program Files (x86)/STEP Tools/STEP-NC Machine/examples/boxy_renton_signed.stpnc")

        '' Start traversing the process within the file.   Uses the active data from finder.
        ctl.StartProject()

        '' Select only workplan start/stop, and individual workingsteps
        ctl.SetWantedAll(False)
        ctl.SetWanted(Adaptive.CtlEvent.EXEC_WORKPLAN_START)
        ctl.SetWanted(Adaptive.CtlEvent.EXEC_WORKPLAN_END)
        ctl.SetWanted(Adaptive.CtlEvent.OPERATION_START)

        While ctl.Next() <> Adaptive.CtlEvent.DONE
            Dim id As Long

            Select Case ctl.Event()
                Case Adaptive.CtlEvent.EXEC_WORKPLAN_START
                    id = ctl.GetActiveWorkplan()
                    'Console.WriteLine("STARTING WORKPLAN #{0} [{1}]", id, finder.GetExecutableName(id))

                Case Adaptive.CtlEvent.EXEC_WORKPLAN_END
                    'Console.WriteLine("ENDING WORKPLAN #{0}", ctl.GetActiveWorkplan())

                Case Adaptive.CtlEvent.OPERATION_START
                    id = ctl.GetActiveExec()
                    '   Console.WriteLine("STARTING OPERATION #{0} (workstep #{1}) [{2}]",
                    'ctl.GetActiveOperation(), id, finder.GetExecutableName(id))

                Case Else
                    'Console.WriteLine("UNEXPECTED EVENT")
            End Select
        End While
    End Sub

    Sub MakeSTEPNC()

        '' Create a trivial STEP-NC file
        Dim apt As STEPNCLib.AptStepMaker = New STEPNCLib.AptStepMaker
        apt.PartNo("test part")
        apt.DefineTool(0.25, 5.0, 1.0, 2.0, 3.0, 4.0, 5.0)
        apt.LoadTool(1)
        apt.Rapid()
        apt.GoToXYZ("point001", 1.0, 12.0, 0.0)
        apt.GoToXYZ("point002", 1.0, 14.0, 0.0)
        apt.SaveAsModules("test")
    End Sub


End Class
